// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/health_checks/v1/health_checks.proto

#include "google/cloud/compute/health_checks/v1/internal/health_checks_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_health_checks_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

HealthChecksTracingConnection::HealthChecksTracingConnection(
    std::shared_ptr<compute_health_checks_v1::HealthChecksConnection> child)
    : child_(std::move(child)) {}

StatusOr<google::cloud::cpp::compute::v1::HealthChecksAggregatedList>
HealthChecksTracingConnection::AggregatedListHealthChecks(
    google::cloud::cpp::compute::health_checks::v1::
        AggregatedListHealthChecksRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_health_checks_v1::HealthChecksConnection::"
      "AggregatedListHealthChecks");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->AggregatedListHealthChecks(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
HealthChecksTracingConnection::DeleteHealthChecks(
    google::cloud::cpp::compute::health_checks::v1::
        DeleteHealthChecksRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_health_checks_v1::HealthChecksConnection::DeleteHealthChecks");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteHealthChecks(request));
}

StatusOr<google::cloud::cpp::compute::v1::HealthCheck>
HealthChecksTracingConnection::GetHealthChecks(
    google::cloud::cpp::compute::health_checks::v1::
        GetHealthChecksRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_health_checks_v1::HealthChecksConnection::GetHealthChecks");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetHealthChecks(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
HealthChecksTracingConnection::InsertHealthChecks(
    google::cloud::cpp::compute::health_checks::v1::
        InsertHealthChecksRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_health_checks_v1::HealthChecksConnection::InsertHealthChecks");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->InsertHealthChecks(request));
}

StreamRange<google::cloud::cpp::compute::v1::HealthCheck>
HealthChecksTracingConnection::ListHealthChecks(
    google::cloud::cpp::compute::health_checks::v1::ListHealthChecksRequest
        request) {
  auto span = internal::MakeSpan(
      "compute_health_checks_v1::HealthChecksConnection::ListHealthChecks");
  auto scope = opentelemetry::trace::Scope(span);
  auto sr = child_->ListHealthChecks(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::cpp::compute::v1::HealthCheck>(std::move(span),
                                                    std::move(sr));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
HealthChecksTracingConnection::PatchHealthChecks(
    google::cloud::cpp::compute::health_checks::v1::
        PatchHealthChecksRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_health_checks_v1::HealthChecksConnection::PatchHealthChecks");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span), child_->PatchHealthChecks(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
HealthChecksTracingConnection::UpdateHealthChecks(
    google::cloud::cpp::compute::health_checks::v1::
        UpdateHealthChecksRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_health_checks_v1::HealthChecksConnection::UpdateHealthChecks");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->UpdateHealthChecks(request));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<compute_health_checks_v1::HealthChecksConnection>
MakeHealthChecksTracingConnection(
    std::shared_ptr<compute_health_checks_v1::HealthChecksConnection> conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<HealthChecksTracingConnection>(std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_health_checks_v1_internal
}  // namespace cloud
}  // namespace google
