// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/images/v1/images.proto

#include "google/cloud/compute/images/v1/images_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_images_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ImagesConnectionIdempotencyPolicy::~ImagesConnectionIdempotencyPolicy() =
    default;

std::unique_ptr<ImagesConnectionIdempotencyPolicy>
ImagesConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<ImagesConnectionIdempotencyPolicy>(*this);
}

Idempotency ImagesConnectionIdempotencyPolicy::DeleteImages(
    google::cloud::cpp::compute::images::v1::DeleteImagesRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency ImagesConnectionIdempotencyPolicy::Deprecate(
    google::cloud::cpp::compute::images::v1::DeprecateRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency ImagesConnectionIdempotencyPolicy::GetImages(
    google::cloud::cpp::compute::images::v1::GetImagesRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency ImagesConnectionIdempotencyPolicy::GetFromFamily(
    google::cloud::cpp::compute::images::v1::GetFromFamilyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency ImagesConnectionIdempotencyPolicy::GetIamPolicy(
    google::cloud::cpp::compute::images::v1::GetIamPolicyRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency ImagesConnectionIdempotencyPolicy::InsertImages(
    google::cloud::cpp::compute::images::v1::InsertImagesRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency ImagesConnectionIdempotencyPolicy::ListImages(
    google::cloud::cpp::compute::images::v1::ListImagesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency ImagesConnectionIdempotencyPolicy::PatchImages(
    google::cloud::cpp::compute::images::v1::PatchImagesRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency ImagesConnectionIdempotencyPolicy::SetIamPolicy(
    google::cloud::cpp::compute::images::v1::SetIamPolicyRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency ImagesConnectionIdempotencyPolicy::SetLabels(
    google::cloud::cpp::compute::images::v1::SetLabelsRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency ImagesConnectionIdempotencyPolicy::TestIamPermissions(
    google::cloud::cpp::compute::images::v1::TestIamPermissionsRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<ImagesConnectionIdempotencyPolicy>
MakeDefaultImagesConnectionIdempotencyPolicy() {
  return std::make_unique<ImagesConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_images_v1
}  // namespace cloud
}  // namespace google
