// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/interconnect_attachments/v1/interconnect_attachments.proto

#include "google/cloud/compute/interconnect_attachments/v1/internal/interconnect_attachments_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_interconnect_attachments_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

InterconnectAttachmentsTracingConnection::
    InterconnectAttachmentsTracingConnection(
        std::shared_ptr<compute_interconnect_attachments_v1::
                            InterconnectAttachmentsConnection>
            child)
    : child_(std::move(child)) {}

StatusOr<google::cloud::cpp::compute::v1::InterconnectAttachmentAggregatedList>
InterconnectAttachmentsTracingConnection::AggregatedListInterconnectAttachments(
    google::cloud::cpp::compute::interconnect_attachments::v1::
        AggregatedListInterconnectAttachmentsRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_interconnect_attachments_v1::InterconnectAttachmentsConnection::"
      "AggregatedListInterconnectAttachments");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(
      *span, child_->AggregatedListInterconnectAttachments(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
InterconnectAttachmentsTracingConnection::DeleteInterconnectAttachments(
    google::cloud::cpp::compute::interconnect_attachments::v1::
        DeleteInterconnectAttachmentsRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_interconnect_attachments_v1::InterconnectAttachmentsConnection::"
      "DeleteInterconnectAttachments");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteInterconnectAttachments(request));
}

StatusOr<google::cloud::cpp::compute::v1::InterconnectAttachment>
InterconnectAttachmentsTracingConnection::GetInterconnectAttachments(
    google::cloud::cpp::compute::interconnect_attachments::v1::
        GetInterconnectAttachmentsRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_interconnect_attachments_v1::InterconnectAttachmentsConnection::"
      "GetInterconnectAttachments");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetInterconnectAttachments(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
InterconnectAttachmentsTracingConnection::InsertInterconnectAttachments(
    google::cloud::cpp::compute::interconnect_attachments::v1::
        InsertInterconnectAttachmentsRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_interconnect_attachments_v1::InterconnectAttachmentsConnection::"
      "InsertInterconnectAttachments");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->InsertInterconnectAttachments(request));
}

StreamRange<google::cloud::cpp::compute::v1::InterconnectAttachment>
InterconnectAttachmentsTracingConnection::ListInterconnectAttachments(
    google::cloud::cpp::compute::interconnect_attachments::v1::
        ListInterconnectAttachmentsRequest request) {
  auto span = internal::MakeSpan(
      "compute_interconnect_attachments_v1::InterconnectAttachmentsConnection::"
      "ListInterconnectAttachments");
  auto scope = opentelemetry::trace::Scope(span);
  auto sr = child_->ListInterconnectAttachments(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::cpp::compute::v1::InterconnectAttachment>(std::move(span),
                                                               std::move(sr));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
InterconnectAttachmentsTracingConnection::PatchInterconnectAttachments(
    google::cloud::cpp::compute::interconnect_attachments::v1::
        PatchInterconnectAttachmentsRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_interconnect_attachments_v1::InterconnectAttachmentsConnection::"
      "PatchInterconnectAttachments");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->PatchInterconnectAttachments(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
InterconnectAttachmentsTracingConnection::SetLabels(
    google::cloud::cpp::compute::interconnect_attachments::v1::
        SetLabelsRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_interconnect_attachments_v1::InterconnectAttachmentsConnection::"
      "SetLabels");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span), child_->SetLabels(request));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<
    compute_interconnect_attachments_v1::InterconnectAttachmentsConnection>
MakeInterconnectAttachmentsTracingConnection(
    std::shared_ptr<
        compute_interconnect_attachments_v1::InterconnectAttachmentsConnection>
        conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<InterconnectAttachmentsTracingConnection>(
        std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_interconnect_attachments_v1_internal
}  // namespace cloud
}  // namespace google
