// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/networks/v1/networks.proto

#include "google/cloud/compute/networks/v1/internal/networks_rest_metadata_decorator.h"
#include "google/cloud/common_options.h"
#include "google/cloud/internal/absl_str_cat_quiet.h"
#include "google/cloud/internal/absl_str_join_quiet.h"
#include "google/cloud/internal/api_client_header.h"
#include "google/cloud/status_or.h"
#include "absl/strings/str_format.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_networks_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

NetworksRestMetadata::NetworksRestMetadata(
    std::shared_ptr<NetworksRestStub> child)
    : child_(std::move(child)),
      api_client_header_(
          google::cloud::internal::ApiClientHeader("generator")) {}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
NetworksRestMetadata::AsyncAddPeering(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::cpp::compute::networks::v1::AddPeeringRequest const&
        request) {
  SetMetadata(*rest_context);
  return child_->AsyncAddPeering(cq, std::move(rest_context), request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
NetworksRestMetadata::AsyncDeleteNetworks(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::cpp::compute::networks::v1::DeleteNetworksRequest const&
        request) {
  SetMetadata(*rest_context);
  return child_->AsyncDeleteNetworks(cq, std::move(rest_context), request);
}

StatusOr<google::cloud::cpp::compute::v1::Network>
NetworksRestMetadata::GetNetworks(
    rest_internal::RestContext& rest_context,
    google::cloud::cpp::compute::networks::v1::GetNetworksRequest const&
        request) {
  SetMetadata(rest_context);
  return child_->GetNetworks(rest_context, request);
}

StatusOr<google::cloud::cpp::compute::v1::NetworksGetEffectiveFirewallsResponse>
NetworksRestMetadata::GetEffectiveFirewalls(
    rest_internal::RestContext& rest_context,
    google::cloud::cpp::compute::networks::v1::
        GetEffectiveFirewallsRequest const& request) {
  SetMetadata(rest_context);
  return child_->GetEffectiveFirewalls(rest_context, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
NetworksRestMetadata::AsyncInsertNetworks(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::cpp::compute::networks::v1::InsertNetworksRequest const&
        request) {
  SetMetadata(*rest_context);
  return child_->AsyncInsertNetworks(cq, std::move(rest_context), request);
}

StatusOr<google::cloud::cpp::compute::v1::NetworkList>
NetworksRestMetadata::ListNetworks(
    rest_internal::RestContext& rest_context,
    google::cloud::cpp::compute::networks::v1::ListNetworksRequest const&
        request) {
  SetMetadata(rest_context);
  return child_->ListNetworks(rest_context, request);
}

StatusOr<google::cloud::cpp::compute::v1::ExchangedPeeringRoutesList>
NetworksRestMetadata::ListPeeringRoutes(
    rest_internal::RestContext& rest_context,
    google::cloud::cpp::compute::networks::v1::ListPeeringRoutesRequest const&
        request) {
  SetMetadata(rest_context);
  return child_->ListPeeringRoutes(rest_context, request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
NetworksRestMetadata::AsyncPatchNetworks(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::cpp::compute::networks::v1::PatchNetworksRequest const&
        request) {
  SetMetadata(*rest_context);
  return child_->AsyncPatchNetworks(cq, std::move(rest_context), request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
NetworksRestMetadata::AsyncRemovePeering(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::cpp::compute::networks::v1::RemovePeeringRequest const&
        request) {
  SetMetadata(*rest_context);
  return child_->AsyncRemovePeering(cq, std::move(rest_context), request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
NetworksRestMetadata::AsyncSwitchToCustomMode(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::cpp::compute::networks::v1::SwitchToCustomModeRequest const&
        request) {
  SetMetadata(*rest_context);
  return child_->AsyncSwitchToCustomMode(cq, std::move(rest_context), request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
NetworksRestMetadata::AsyncUpdatePeering(
    CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::cpp::compute::networks::v1::UpdatePeeringRequest const&
        request) {
  SetMetadata(*rest_context);
  return child_->AsyncUpdatePeering(cq, std::move(rest_context), request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
NetworksRestMetadata::AsyncGetOperation(
    google::cloud::CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::cpp::compute::global_operations::v1::
        GetGlobalOperationsRequest const& request) {
  SetMetadata(*rest_context);
  return child_->AsyncGetOperation(cq, std::move(rest_context), request);
}

future<Status> NetworksRestMetadata::AsyncCancelOperation(
    google::cloud::CompletionQueue& cq,
    std::unique_ptr<rest_internal::RestContext> rest_context,
    google::cloud::cpp::compute::global_operations::v1::
        DeleteGlobalOperationsRequest const& request) {
  SetMetadata(*rest_context);
  return child_->AsyncCancelOperation(cq, std::move(rest_context), request);
}

void NetworksRestMetadata::SetMetadata(rest_internal::RestContext& rest_context,
                                       std::vector<std::string> const& params) {
  rest_context.AddHeader("x-goog-api-client", api_client_header_);
  if (!params.empty()) {
    rest_context.AddHeader("x-goog-request-params", absl::StrJoin(params, "&"));
  }
  auto const& options = internal::CurrentOptions();
  if (options.has<UserProjectOption>()) {
    rest_context.AddHeader("x-goog-user-project",
                           options.get<UserProjectOption>());
  }
  if (options.has<google::cloud::QuotaUserOption>()) {
    rest_context.AddHeader("x-goog-quota-user",
                           options.get<google::cloud::QuotaUserOption>());
  }
  if (options.has<google::cloud::ServerTimeoutOption>()) {
    auto ms_rep = absl::StrCat(
        absl::Dec(options.get<google::cloud::ServerTimeoutOption>().count(),
                  absl::kZeroPad4));
    rest_context.AddHeader("x-server-timeout",
                           ms_rep.insert(ms_rep.size() - 3, "."));
  }
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_networks_v1_internal
}  // namespace cloud
}  // namespace google
