// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/public_delegated_prefixes/v1/public_delegated_prefixes.proto

#include "google/cloud/compute/public_delegated_prefixes/v1/internal/public_delegated_prefixes_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_public_delegated_prefixes_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

PublicDelegatedPrefixesTracingConnection::
    PublicDelegatedPrefixesTracingConnection(
        std::shared_ptr<compute_public_delegated_prefixes_v1::
                            PublicDelegatedPrefixesConnection>
            child)
    : child_(std::move(child)) {}

StatusOr<google::cloud::cpp::compute::v1::PublicDelegatedPrefixAggregatedList>
PublicDelegatedPrefixesTracingConnection::AggregatedListPublicDelegatedPrefixes(
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        AggregatedListPublicDelegatedPrefixesRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_public_delegated_prefixes_v1::PublicDelegatedPrefixesConnection:"
      ":AggregatedListPublicDelegatedPrefixes");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(
      *span, child_->AggregatedListPublicDelegatedPrefixes(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicDelegatedPrefixesTracingConnection::DeletePublicDelegatedPrefixes(
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        DeletePublicDelegatedPrefixesRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_public_delegated_prefixes_v1::PublicDelegatedPrefixesConnection:"
      ":DeletePublicDelegatedPrefixes");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeletePublicDelegatedPrefixes(request));
}

StatusOr<google::cloud::cpp::compute::v1::PublicDelegatedPrefix>
PublicDelegatedPrefixesTracingConnection::GetPublicDelegatedPrefixes(
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        GetPublicDelegatedPrefixesRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_public_delegated_prefixes_v1::PublicDelegatedPrefixesConnection:"
      ":GetPublicDelegatedPrefixes");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetPublicDelegatedPrefixes(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicDelegatedPrefixesTracingConnection::InsertPublicDelegatedPrefixes(
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        InsertPublicDelegatedPrefixesRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_public_delegated_prefixes_v1::PublicDelegatedPrefixesConnection:"
      ":InsertPublicDelegatedPrefixes");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->InsertPublicDelegatedPrefixes(request));
}

StreamRange<google::cloud::cpp::compute::v1::PublicDelegatedPrefix>
PublicDelegatedPrefixesTracingConnection::ListPublicDelegatedPrefixes(
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        ListPublicDelegatedPrefixesRequest request) {
  auto span = internal::MakeSpan(
      "compute_public_delegated_prefixes_v1::PublicDelegatedPrefixesConnection:"
      ":ListPublicDelegatedPrefixes");
  auto scope = opentelemetry::trace::Scope(span);
  auto sr = child_->ListPublicDelegatedPrefixes(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::cpp::compute::v1::PublicDelegatedPrefix>(std::move(span),
                                                              std::move(sr));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
PublicDelegatedPrefixesTracingConnection::PatchPublicDelegatedPrefixes(
    google::cloud::cpp::compute::public_delegated_prefixes::v1::
        PatchPublicDelegatedPrefixesRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_public_delegated_prefixes_v1::PublicDelegatedPrefixesConnection:"
      ":PatchPublicDelegatedPrefixes");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->PatchPublicDelegatedPrefixes(request));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<
    compute_public_delegated_prefixes_v1::PublicDelegatedPrefixesConnection>
MakePublicDelegatedPrefixesTracingConnection(
    std::shared_ptr<
        compute_public_delegated_prefixes_v1::PublicDelegatedPrefixesConnection>
        conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<PublicDelegatedPrefixesTracingConnection>(
        std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_public_delegated_prefixes_v1_internal
}  // namespace cloud
}  // namespace google
