// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/region_security_policies/v1/region_security_policies.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_SECURITY_POLICIES_V1_REGION_SECURITY_POLICIES_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_SECURITY_POLICIES_V1_REGION_SECURITY_POLICIES_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/region_security_policies/v1/region_security_policies.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_region_security_policies_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class RegionSecurityPoliciesConnectionIdempotencyPolicy {
 public:
  virtual ~RegionSecurityPoliciesConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<RegionSecurityPoliciesConnectionIdempotencyPolicy>
  clone() const;

  virtual google::cloud::Idempotency DeleteRegionSecurityPolicies(
      google::cloud::cpp::compute::region_security_policies::v1::
          DeleteRegionSecurityPoliciesRequest const& request);

  virtual google::cloud::Idempotency GetRegionSecurityPolicies(
      google::cloud::cpp::compute::region_security_policies::v1::
          GetRegionSecurityPoliciesRequest const& request);

  virtual google::cloud::Idempotency InsertRegionSecurityPolicies(
      google::cloud::cpp::compute::region_security_policies::v1::
          InsertRegionSecurityPoliciesRequest const& request);

  virtual google::cloud::Idempotency ListRegionSecurityPolicies(
      google::cloud::cpp::compute::region_security_policies::v1::
          ListRegionSecurityPoliciesRequest request);

  virtual google::cloud::Idempotency PatchRegionSecurityPolicies(
      google::cloud::cpp::compute::region_security_policies::v1::
          PatchRegionSecurityPoliciesRequest const& request);
};

std::unique_ptr<RegionSecurityPoliciesConnectionIdempotencyPolicy>
MakeDefaultRegionSecurityPoliciesConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_security_policies_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_SECURITY_POLICIES_V1_REGION_SECURITY_POLICIES_CONNECTION_IDEMPOTENCY_POLICY_H
