// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/resource_policies/v1/resource_policies.proto

#include "google/cloud/compute/resource_policies/v1/resource_policies_client.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_resource_policies_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

ResourcePoliciesClient::ResourcePoliciesClient(
    ExperimentalTag, std::shared_ptr<ResourcePoliciesConnection> connection,
    Options opts)
    : connection_(std::move(connection)),
      options_(
          internal::MergeOptions(std::move(opts), connection_->options())) {}
ResourcePoliciesClient::~ResourcePoliciesClient() = default;

StatusOr<google::cloud::cpp::compute::v1::ResourcePolicyAggregatedList>
ResourcePoliciesClient::AggregatedListResourcePolicies(
    std::string const& project, Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  google::cloud::cpp::compute::resource_policies::v1::
      AggregatedListResourcePoliciesRequest request;
  request.set_project(project);
  return connection_->AggregatedListResourcePolicies(request);
}

StatusOr<google::cloud::cpp::compute::v1::ResourcePolicyAggregatedList>
ResourcePoliciesClient::AggregatedListResourcePolicies(
    google::cloud::cpp::compute::resource_policies::v1::
        AggregatedListResourcePoliciesRequest const& request,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  return connection_->AggregatedListResourcePolicies(request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
ResourcePoliciesClient::DeleteResourcePolicies(
    std::string const& project, std::string const& region,
    std::string const& resource_policy, Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  google::cloud::cpp::compute::resource_policies::v1::
      DeleteResourcePoliciesRequest request;
  request.set_project(project);
  request.set_region(region);
  request.set_resource_policy(resource_policy);
  return connection_->DeleteResourcePolicies(request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
ResourcePoliciesClient::DeleteResourcePolicies(
    google::cloud::cpp::compute::resource_policies::v1::
        DeleteResourcePoliciesRequest const& request,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  return connection_->DeleteResourcePolicies(request);
}

StatusOr<google::cloud::cpp::compute::v1::ResourcePolicy>
ResourcePoliciesClient::GetResourcePolicies(std::string const& project,
                                            std::string const& region,
                                            std::string const& resource_policy,
                                            Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  google::cloud::cpp::compute::resource_policies::v1::GetResourcePoliciesRequest
      request;
  request.set_project(project);
  request.set_region(region);
  request.set_resource_policy(resource_policy);
  return connection_->GetResourcePolicies(request);
}

StatusOr<google::cloud::cpp::compute::v1::ResourcePolicy>
ResourcePoliciesClient::GetResourcePolicies(
    google::cloud::cpp::compute::resource_policies::v1::
        GetResourcePoliciesRequest const& request,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  return connection_->GetResourcePolicies(request);
}

StatusOr<google::cloud::cpp::compute::v1::Policy>
ResourcePoliciesClient::GetIamPolicy(std::string const& project,
                                     std::string const& region,
                                     std::string const& resource,
                                     Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  google::cloud::cpp::compute::resource_policies::v1::GetIamPolicyRequest
      request;
  request.set_project(project);
  request.set_region(region);
  request.set_resource(resource);
  return connection_->GetIamPolicy(request);
}

StatusOr<google::cloud::cpp::compute::v1::Policy>
ResourcePoliciesClient::GetIamPolicy(
    google::cloud::cpp::compute::resource_policies::v1::
        GetIamPolicyRequest const& request,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  return connection_->GetIamPolicy(request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
ResourcePoliciesClient::InsertResourcePolicies(
    std::string const& project, std::string const& region,
    google::cloud::cpp::compute::v1::ResourcePolicy const&
        resource_policy_resource,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  google::cloud::cpp::compute::resource_policies::v1::
      InsertResourcePoliciesRequest request;
  request.set_project(project);
  request.set_region(region);
  *request.mutable_resource_policy_resource() = resource_policy_resource;
  return connection_->InsertResourcePolicies(request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
ResourcePoliciesClient::InsertResourcePolicies(
    google::cloud::cpp::compute::resource_policies::v1::
        InsertResourcePoliciesRequest const& request,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  return connection_->InsertResourcePolicies(request);
}

StreamRange<google::cloud::cpp::compute::v1::ResourcePolicy>
ResourcePoliciesClient::ListResourcePolicies(std::string const& project,
                                             std::string const& region,
                                             Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  google::cloud::cpp::compute::resource_policies::v1::
      ListResourcePoliciesRequest request;
  request.set_project(project);
  request.set_region(region);
  return connection_->ListResourcePolicies(request);
}

StreamRange<google::cloud::cpp::compute::v1::ResourcePolicy>
ResourcePoliciesClient::ListResourcePolicies(
    google::cloud::cpp::compute::resource_policies::v1::
        ListResourcePoliciesRequest request,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  return connection_->ListResourcePolicies(std::move(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
ResourcePoliciesClient::PatchResourcePolicies(
    std::string const& project, std::string const& region,
    std::string const& resource_policy,
    google::cloud::cpp::compute::v1::ResourcePolicy const&
        resource_policy_resource,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  google::cloud::cpp::compute::resource_policies::v1::
      PatchResourcePoliciesRequest request;
  request.set_project(project);
  request.set_region(region);
  request.set_resource_policy(resource_policy);
  *request.mutable_resource_policy_resource() = resource_policy_resource;
  return connection_->PatchResourcePolicies(request);
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
ResourcePoliciesClient::PatchResourcePolicies(
    google::cloud::cpp::compute::resource_policies::v1::
        PatchResourcePoliciesRequest const& request,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  return connection_->PatchResourcePolicies(request);
}

StatusOr<google::cloud::cpp::compute::v1::Policy>
ResourcePoliciesClient::SetIamPolicy(
    std::string const& project, std::string const& region,
    std::string const& resource,
    google::cloud::cpp::compute::v1::RegionSetPolicyRequest const&
        region_set_policy_request_resource,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  google::cloud::cpp::compute::resource_policies::v1::SetIamPolicyRequest
      request;
  request.set_project(project);
  request.set_region(region);
  request.set_resource(resource);
  *request.mutable_region_set_policy_request_resource() =
      region_set_policy_request_resource;
  return connection_->SetIamPolicy(request);
}

StatusOr<google::cloud::cpp::compute::v1::Policy>
ResourcePoliciesClient::SetIamPolicy(
    google::cloud::cpp::compute::resource_policies::v1::
        SetIamPolicyRequest const& request,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  return connection_->SetIamPolicy(request);
}

StatusOr<google::cloud::cpp::compute::v1::TestPermissionsResponse>
ResourcePoliciesClient::TestIamPermissions(
    std::string const& project, std::string const& region,
    std::string const& resource,
    google::cloud::cpp::compute::v1::TestPermissionsRequest const&
        test_permissions_request_resource,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  google::cloud::cpp::compute::resource_policies::v1::TestIamPermissionsRequest
      request;
  request.set_project(project);
  request.set_region(region);
  request.set_resource(resource);
  *request.mutable_test_permissions_request_resource() =
      test_permissions_request_resource;
  return connection_->TestIamPermissions(request);
}

StatusOr<google::cloud::cpp::compute::v1::TestPermissionsResponse>
ResourcePoliciesClient::TestIamPermissions(
    google::cloud::cpp::compute::resource_policies::v1::
        TestIamPermissionsRequest const& request,
    Options opts) {
  internal::OptionsSpan span(internal::MergeOptions(std::move(opts), options_));
  return connection_->TestIamPermissions(request);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_resource_policies_v1
}  // namespace cloud
}  // namespace google
