// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/ssl_certificates/v1/ssl_certificates.proto

#include "google/cloud/compute/ssl_certificates/v1/internal/ssl_certificates_tracing_connection.h"
#include "google/cloud/internal/opentelemetry.h"
#include "google/cloud/internal/traced_stream_range.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_ssl_certificates_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

SslCertificatesTracingConnection::SslCertificatesTracingConnection(
    std::shared_ptr<compute_ssl_certificates_v1::SslCertificatesConnection>
        child)
    : child_(std::move(child)) {}

StatusOr<google::cloud::cpp::compute::v1::SslCertificateAggregatedList>
SslCertificatesTracingConnection::AggregatedListSslCertificates(
    google::cloud::cpp::compute::ssl_certificates::v1::
        AggregatedListSslCertificatesRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_ssl_certificates_v1::SslCertificatesConnection::"
      "AggregatedListSslCertificates");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span,
                           child_->AggregatedListSslCertificates(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
SslCertificatesTracingConnection::DeleteSslCertificates(
    google::cloud::cpp::compute::ssl_certificates::v1::
        DeleteSslCertificatesRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_ssl_certificates_v1::SslCertificatesConnection::"
      "DeleteSslCertificates");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->DeleteSslCertificates(request));
}

StatusOr<google::cloud::cpp::compute::v1::SslCertificate>
SslCertificatesTracingConnection::GetSslCertificates(
    google::cloud::cpp::compute::ssl_certificates::v1::
        GetSslCertificatesRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_ssl_certificates_v1::SslCertificatesConnection::"
      "GetSslCertificates");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(*span, child_->GetSslCertificates(request));
}

future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
SslCertificatesTracingConnection::InsertSslCertificates(
    google::cloud::cpp::compute::ssl_certificates::v1::
        InsertSslCertificatesRequest const& request) {
  auto span = internal::MakeSpan(
      "compute_ssl_certificates_v1::SslCertificatesConnection::"
      "InsertSslCertificates");
  auto scope = opentelemetry::trace::Scope(span);
  return internal::EndSpan(std::move(span),
                           child_->InsertSslCertificates(request));
}

StreamRange<google::cloud::cpp::compute::v1::SslCertificate>
SslCertificatesTracingConnection::ListSslCertificates(
    google::cloud::cpp::compute::ssl_certificates::v1::
        ListSslCertificatesRequest request) {
  auto span = internal::MakeSpan(
      "compute_ssl_certificates_v1::SslCertificatesConnection::"
      "ListSslCertificates");
  auto scope = opentelemetry::trace::Scope(span);
  auto sr = child_->ListSslCertificates(std::move(request));
  return internal::MakeTracedStreamRange<
      google::cloud::cpp::compute::v1::SslCertificate>(std::move(span),
                                                       std::move(sr));
}

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

std::shared_ptr<compute_ssl_certificates_v1::SslCertificatesConnection>
MakeSslCertificatesTracingConnection(
    std::shared_ptr<compute_ssl_certificates_v1::SslCertificatesConnection>
        conn) {
#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  if (internal::TracingEnabled(conn->options())) {
    conn = std::make_shared<SslCertificatesTracingConnection>(std::move(conn));
  }
#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY
  return conn;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_ssl_certificates_v1_internal
}  // namespace cloud
}  // namespace google
