// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/ssl_policies/v1/ssl_policies.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_SSL_POLICIES_V1_MOCKS_MOCK_SSL_POLICIES_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_SSL_POLICIES_V1_MOCKS_MOCK_SSL_POLICIES_CONNECTION_H

#include "google/cloud/compute/ssl_policies/v1/ssl_policies_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace compute_ssl_policies_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `SslPoliciesConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `SslPoliciesClient`. To do so,
 * construct an object of type `SslPoliciesClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockSslPoliciesConnection
    : public compute_ssl_policies_v1::SslPoliciesConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(
      StatusOr<google::cloud::cpp::compute::v1::SslPoliciesAggregatedList>,
      AggregatedListSslPolicies,
      (google::cloud::cpp::compute::ssl_policies::v1::
           AggregatedListSslPoliciesRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              DeleteSslPolicies,
              (google::cloud::cpp::compute::ssl_policies::v1::
                   DeleteSslPoliciesRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::SslPolicy>,
              GetSslPolicies,
              (google::cloud::cpp::compute::ssl_policies::v1::
                   GetSslPoliciesRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              InsertSslPolicies,
              (google::cloud::cpp::compute::ssl_policies::v1::
                   InsertSslPoliciesRequest const& request),
              (override));

  MOCK_METHOD(
      StreamRange<google::cloud::cpp::compute::v1::SslPolicy>, ListSslPolicies,
      (google::cloud::cpp::compute::ssl_policies::v1::ListSslPoliciesRequest
           request),
      (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::
                           SslPoliciesListAvailableFeaturesResponse>,
              ListAvailableFeatures,
              (google::cloud::cpp::compute::ssl_policies::v1::
                   ListAvailableFeaturesRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              PatchSslPolicies,
              (google::cloud::cpp::compute::ssl_policies::v1::
                   PatchSslPoliciesRequest const& request),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_ssl_policies_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_SSL_POLICIES_V1_MOCKS_MOCK_SSL_POLICIES_CONNECTION_H
