// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/url_maps/v1/url_maps.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_URL_MAPS_V1_URL_MAPS_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_URL_MAPS_V1_URL_MAPS_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/url_maps/v1/url_maps.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_url_maps_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class UrlMapsConnectionIdempotencyPolicy {
 public:
  virtual ~UrlMapsConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<UrlMapsConnectionIdempotencyPolicy> clone() const;

  virtual google::cloud::Idempotency AggregatedListUrlMaps(
      google::cloud::cpp::compute::url_maps::v1::
          AggregatedListUrlMapsRequest const& request);

  virtual google::cloud::Idempotency DeleteUrlMaps(
      google::cloud::cpp::compute::url_maps::v1::DeleteUrlMapsRequest const&
          request);

  virtual google::cloud::Idempotency GetUrlMaps(
      google::cloud::cpp::compute::url_maps::v1::GetUrlMapsRequest const&
          request);

  virtual google::cloud::Idempotency InsertUrlMaps(
      google::cloud::cpp::compute::url_maps::v1::InsertUrlMapsRequest const&
          request);

  virtual google::cloud::Idempotency InvalidateCache(
      google::cloud::cpp::compute::url_maps::v1::InvalidateCacheRequest const&
          request);

  virtual google::cloud::Idempotency ListUrlMaps(
      google::cloud::cpp::compute::url_maps::v1::ListUrlMapsRequest request);

  virtual google::cloud::Idempotency PatchUrlMaps(
      google::cloud::cpp::compute::url_maps::v1::PatchUrlMapsRequest const&
          request);

  virtual google::cloud::Idempotency UpdateUrlMaps(
      google::cloud::cpp::compute::url_maps::v1::UpdateUrlMapsRequest const&
          request);

  virtual google::cloud::Idempotency Validate(
      google::cloud::cpp::compute::url_maps::v1::ValidateRequest const&
          request);
};

std::unique_ptr<UrlMapsConnectionIdempotencyPolicy>
MakeDefaultUrlMapsConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_url_maps_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_URL_MAPS_V1_URL_MAPS_CONNECTION_IDEMPOTENCY_POLICY_H
